--
-- BergmannShuttle900K
--
-- @author  Stefan Geiger
-- @date  08/12/10
--
-- Copyright (C) GIANTS Software GmbH, Confidential, All Rights Reserved.

BergmannShuttle900K = {};

function BergmannShuttle900K.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function BergmannShuttle900K:load(xmlFile)

    self.tipRotationNodes = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.tipRotationNodes.tipRotationNode(%d)", i);
        if not hasXMLProperty(xmlFile, key) then
            break;
        end;
        local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
        local rotSpeed = math.rad(Utils.getNoNil(getXMLFloat(xmlFile, key.."#rotSpeed"), 1)*0.001);
        if node ~= nil then
            table.insert(self.tipRotationNodes, {node=node, rotSpeed=rotSpeed});
        end;
        i = i + 1;
    end;
end;

function BergmannShuttle900K:delete()
end;

function BergmannShuttle900K:mouseEvent(posX, posY, isDown, isUp, button)
end;

function BergmannShuttle900K:keyEvent(unicode, sym, modifier, isDown)
end;

function BergmannShuttle900K:readStream(streamId, connection)
end;

function BergmannShuttle900K:writeStream(streamId, connection)
end;

function BergmannShuttle900K:readUpdateStream(streamId, timestamp, connection)
end;

function BergmannShuttle900K:writeUpdateStream(streamId, connection, dirtyMask)
end;

function BergmannShuttle900K:update(dt)
    if self.tipState ~= Trailer.TIPSTATE_CLOSED then
        for _, node in pairs(self.tipRotationNodes) do
            rotate(node.node, -dt*node.rotSpeed, 0, 0);
        end;
    end;
end;

function BergmannShuttle900K:updateTick(dt)
end;

function BergmannShuttle900K:draw()
end;
